;Contador de PIC - 16F84 - Artigo revista Saber Eletronica

LIST           P=16C84

pc             equ       2
stat           equ       3
fsr            equ       4
PA             equ       5
rb             equ       6
eedat          equ       8
eeadr          equ       9
eecon1         equ       8h
eecon2         equ       9h
;====================================   bit
z              equ       2h
c              equ       0h
w              equ       0h
r              equ       1h

FlPu           equ       0h   ;Flanco  de  Pulso
MLeD           equ       2h   ;Memoria Lectura  de  Datos
Dec            equ       5h   ;Decremento
DeP0           equ       6h   ;Deteccion de Paso Por 0
IDRa           equ       7h   ;Incremento Decremento Rapido

INCRE          equ       0h
DECRE          equ       1h            
MEMOR          equ       2h            

;===================================   RAM     
PunDig         equ       10h
RotDig         equ       11h
TemMul         equ       12h
TTecla.00      equ       13h     
TTecla.01      equ       14h     
r13            equ       15h
r14            equ       16h
T00.Pulsos     equ       17h
TemRe0         equ       19h     
TemRe1         equ       1Ah
TemLed0        equ       1Bh
TemLed1        equ       1Ch
TMemo.00       equ       1Dh
TMemo.01       equ       1Eh
TMemo.02       equ       1Fh 

Dig0           equ       20h
Dig1           equ       21h
Dig2           equ       22h

Dig0Re0        equ       28h
Dig1Re1        equ       29h
Dig2Re2        equ       2Ah


flag           equ       30h
IncDec         equ       31h
TemMu0         equ       32h
TemLed2        equ       33h







                org        00h
Re_ta_1        decfsz    r13,r
               goto      Re_ta_1                                                      
               decfsz    r14,r
               goto      Re_ta_1
               goto       INI__CIO





;====================================    Retardo                
RETARDO        movlw     00H
               movwf     r14
Re_ta          decfsz    r13,r
               goto      Re_ta                                                      
               decfsz    r14,r
               goto      Re_ta     
               RETLW     0


















;=====================================     INCREMEMTAR  DIGITO     
INCREMENT                     movlw     20H
                              movwf     fsr

Rep_Inc                       incf      00H
                    movlw     0AH
                    subwf     00H,w
                    btfss     stat,z
                    RETURN

                              clrf      00h
                              incf      fsr,r
                              goto      Rep_Inc


;======================================     DECREMENTAR  DIGITO         
DECREMEN                     movlw     20H
                             movwf     fsr

Rep_Dec                       decf      00h
                    movlw     0FFH
                    subwf     00H,w
                    btfss     stat,z
                    goto      Det_0
                              movlw     09H
                              movwf     00h
                              incf      fsr,r
                    goto      Rep_Dec
                    
Det_0                         movlw     20H
                              movwf     fsr

O_det_                        movlw     00H
                              subwf     00H,w
                              btfss     stat,z
                              RETLW     01H

                              incf      fsr,r
                              movlw     23H
                              subwf     fsr,w
                              btfss     stat,z
                              goto      O_det_
                              RETLW     00H


;==============================================
CLEARDIG                      clrf      Dig0
                              clrf      Dig1
                              clrf      Dig2
                              RETURN



































;====================================   Grabar  Digitos           
GrabDigi1      bsf       stat,5     ; Entrar  eeadr y  eedat
               bsf       eecon1,2
               movlw     55H
               movwf     eecon2
               movlw     0AAH
               movwf     eecon2
               bsf       eecon1,1

eesi           btfss     eecon1,4
               goto      eesi
                               
               bcf       eecon1,4
               bcf       stat,5
               return



GrabDigis      movlw     00H       ;  adress  eeprom
               movwf     eeadr
               movlw     20H       ;  adress  ram
               movwf     fsr

gra_dig        movfw     00h
               andlw     0FH
               movwf     eedat
               call      GrabDigi1
               incf      eeadr,r
               incf      fsr,r

               movfw     eeadr
               sublw     03H        ;  examinar  #  pos.mem
               btfss     stat,z
               goto      gra_dig
               return


;=====================================      Leer   EEPROM             
LeerDigi1      bsf       stat,5    ;  entrar  eeadr  pos.mem
               bsf       eecon1,0
               bcf       stat,5
               movfw     eedat
               return



LeerDigis      movlw     00H       ;  adress  eeprom
               movwf     eeadr
               movlw     20H       ;  adress  ram
               movwf     fsr

Lee_dig        call      LeerDigi1
               movwf     00H
               incf      eeadr,r
               incf      fsr,r

               movfw     eeadr
               sublw     03H        ;  examinar  #  pos.mem
               btfss     stat,z
               goto      Lee_dig
               return




;==================================================
CompDigis                     movlw     00H                          
                              movwf     eeadr
                              movlw     20H                             
                              movwf     fsr

Com_dig                       call      LeerDigi1
                    bcf       stat,c
                    subwf     00H,w
                    btfss     stat,z
                    return
                              incf      eeadr,r
                              incf      fsr,r

                    movfw     eeadr
                    sublw     03H        ;  examinar  #  pos.mem
                    btfss     stat,z
                    goto      Com_dig
                              bcf       PA,4
                    return






;=================================================
GUARDAT                       movfw     Dig0
                              movwf     Dig0Re0
                              movfw     Dig1
                              movwf     Dig1Re1
                              movfw     Dig2
                              movwf     Dig2Re2
                              RETURN


SACARDAT                      movfw     Dig0Re0
                              movwf     Dig0
                              movfw     Dig1Re1
                              movwf     Dig1
                              movfw     Dig2Re2
                              movwf     Dig2
                              RETUEN






























;===========================================   TECLADO
TECLADO                       movlw     30H
                              movwf     TemRe1
                    decfsz    TTecla.00
                    RETURN
                    decfsz    TTecla.01
                    RETURN                    
                              movlw     60H
                              movwf     TTecla.01


                    btfss     flag,IDRa
                    goto      Con_Len
                              movlw     10H 
                              movwf     TTecla.01


Con_Len                       bsf       flag,IDRa
                              bcf       flag,DeP0



                    btfss     PA,INCRE          
                    goto      T__Decr

                              btfsc     PA,4
                              goto      Tes_PA
                              bsf       PA,4
                              RETURN

Tes_PA                        CALL      INCREMENT
                              RETURN



T__Decr             btfss     PA,DECRE         
                    goto      T__Memo

                              btfsc     PA,4
                              goto      Tes_PA_0
                              bsf       PA,4
                              RETURN

Tes_PA_0                      CALL      DECREMEN
                              RETURN


T__Memo             btfss     PA,MEMOR      
                    RETURN
                   
                    btfss     flag,MLeD
                    goto      gra_0
                              bcf       flag,MLeD
                              CALL      GUARDAT 
                              call      LeerDigis
                              bsf       flag,Dec
                              bsf       IncDec,1

gra_0               decfsz    TMemo.00
                    RETURN
                              bcf       flag,Dec
                              bcf       IncDec,1
                              movlw     40h
                              movwf     TMemo.00
                              movlw     0FFh
                              movwf     rb
                              CALL      RETARDO

                    decfsz    TMemo.01
                    RETURN                  
                              CALL      SACARDAT
                              movlw     01H
                              movwf     TMemo.01
                    decfsz    TMemo.02
                    RETURN                  
                              call      GrabDigis
                              movlw     0FFh
                              movwf     rb
                              CALL      RETARDO
                              CALL      RETARDO
                              call      LeerDigis
                              RETURN













;==========================================   ENTRADA  DE  PULSOS
ENTRPULS            decfsz    T00.Pulsos
                    RETURN             

                    btfss     flag,FlPu
                    RETURN

                    bcf       flag,FlPu
                    btfss     flag,Dec
                    goto      Pul_Dec
                              CALL      INCREMENT
                              call      CompDigis
                              RETURN              


Pul_Dec             btfsc     flag,DeP0
                    RETURN              

                              CALL      DECREMEN
                              sublw     00H
                    btfss     stat,z
                    RETURN            
                              bcf       PA,4
                              bsf       flag,DeP0
                    RETURN             
















;////////////////////////////////////////////    Tabla     ////////////
Tabla          addwf    pc,r

               retlw     81H 
               retlw    0F3H 
               retlw     49H 
               retlw     61H 
               retlw     33H 
               retlw     25H 
               retlw     05H 
               retlw    0F1H 
               retlw     01H 
               retlw     21H 



               retlw    0C0H 
               retlw    0F9H 
               retlw    0A4H 
               retlw    0B0H 
               retlw     99H 
               retlw     92H 
               retlw     82H 
               retlw    0F8H 
               retlw     80H 
               retlw     90H 











































































































































;=========================================================================
;====================================     Inicio    ======================
INI__CIO                    
                              bsf       stat,5
                              movlw     0E8H
                              movwf     PA
                              movlw     01H       
                              movwf     rb
                              bcf       stat,5
                              bsf       PA,4

                              movlw     04h
                              movwf     RotDig

                              call      LeerDigis

                              bsf       flag,Dec

                              movlw     01H
                              movwf     TemMul
                              movwf     TemMu0

                              bsf       PA,4
                              bcf       IncDec,1

































;=====================================    Multiplexacion  Digitos       
MUL__DIG            decfsz    TemMul
                    goto      Ent_Tec
                    decfsz    TemMu0
                    goto      Ent_Tec
                    movlw     03H
                    movwf     TemMu0


                         bcf       stat,c
                         rlf       RotDig,r
               btfss     RotDig,3
               goto      Mu_Di_0
                         movlw     01H
                         movwf     RotDig
                         movlw     20H
                         movwf     PunDig


Mu_Di_0                 
                         movlw     0F8H
                         andwf     PA,r

                         movf      PunDig,w
                         movwf     fsr
                         movfw     00h
                         andlw     0Fh
                         call      Tabla
                         movwf     rb
                         incf      PunDig,r

                         movfw     RotDig
                         iorwf     PA,r


Ent_Tec                  nop
















































;=================================      ENTRADA DE  TECLADO     
ENT__TEC            btfss     PA,3
                    goto      EnTe_3

                    CALL      TECLADO
                    goto      X__En__Te




EnTe_3
                    decfsz    TemRe0
                    goto      X__En__Te
                    decfsz    TemRe1
                    goto      X__En__Te
                              bcf       flag,IDRa
                              bsf       flag,MLeD
                              movlw     01H
                              movwf     TTecla.01
                              movlw     06H
                              movwf     TMemo.00
                              movlw     02H
                              movwf     TMemo.01
                              movlw     02H
                              movwf     TMemo.02

                    btfss     IncDec,1
                    goto      X__En__Te
                              bcf       IncDec,1
                              call      CLEARDIG
X__En__Te           nop                 























;====================================   Entrada De Pulsos
Con__Pul            btfsc     rb,0
                    goto      No_Pu 

                    CALL      ENTRPULS
                    goto      S__CoPu



No_Pu               bsf       flag,FlPu
                    clrf      T00.Pulsos

S__CoPu             nop




























s_tem_led           goto      MUL__DIG
                    END



