;*******************************************************************************
; Programa: Pisca um led na saida determinada
; arquivo: ledrc.asm
;*******************************************************************************
            list p=16f84
;
            include "P16F84.INC"
;
            __config _CP_OFF & _PWRTE_ON & _WDT_OFF & _RC_OSC
;*******************************************************************************
;           area de declaracao de equ
;*******************************************************************************
led         equ     6           ;determina saida para o led
;*******************************************************************************
;           vetor do reset
;*******************************************************************************
            org 0h              ;endereco do vetor do reset
            goto start          ;vai para o inicio do programa
;*******************************************************************************
;           Area de subrotinas
;*******************************************************************************
;           delay (utiliza TMR0 sem habilitar interrupcao)
;*******************************************************************************
delay:      clrf TMR0           ;zera TMR0
            movlw 0ffh          ;valor maximo do TMR0
            xorwf TMR0,W        ;compara W com TMR0
            btfss STATUS,Z      ;se igual finaliza funcao
            goto $-3            ;senao repete o ciclo
            return
;*******************************************************************************
;           segmento de inicializacao
;*******************************************************************************
start:      bsf STATUS,RP0      ;ativa Bank1
            movlw 0xc7          ;configura o registro option habilitando
            movwf OPTION_REG    ;timer0 com prescaler 1:256
            bcf TRISB,led       ;configura portb.led como saida
            bcf STATUS,RP0      ;ativa Bank0
;*******************************************************************************
;           segmento principal
;*******************************************************************************
loop:       bsf PORTB,led       ;liga led
            call delay          ;aguarda
            bcf PORTB,led       ;desliga led
            call delay          ;aguarda
            goto loop           ;repete o ciclo
;*******************************************************************************
            end
;*******************************************************************************
