;========================================================================
;	Programa exemplo do 12C508 para o livro "Microcontroladores PIC"
;
;	Objetivo: 	Demonstrar o funcionamento do 12C508
;	Funcionamento: 	
;
;	Agosto/97
;========================================================================

	list p=12c508		; processador 12C508
	radix	dec		; define padrao DECIMAL para valores sem identificacao
	include	<P12C508.INC>	; anexa o arquivo que contem as definicoes do 12C508

;.....................................................................................
;				Tabela de definicoes de RAM e constantes.

tempo	equ	0CH		; define variavel auxiliar tempo na RAM 0CH. (primeira posicao)
X	equ	0DH
Y	equ	0EH

LED6	EQU	0		; led 6 em gpio.0	
LED7	EQU	1		; led 7 em gpio.1
S2	EQU	5		; S2 em gpio.5
S3	EQU	4		; S3 em gpio.4

;----------------------------- Memoria de Programa -----------------------------------

	org	0		; define inicio do trecho a seguir em 000

	movlw	B'00000000'	; W = 0
	OPTION

	movlw	B'11111100'	; W = 11111100
	TRIS	GPIO		; 

;. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
principal:			;inicio do programa principal.


	btfss	GPIO,S2		; se S2 = off pula
	goto 	S2On		; S2 press
	btfss	GPIO,S3		; se S3 = off pula
	goto 	S3On		; S3 press

Pisca1:				; S2 e S3 soltas
	bcf	GPIO,LED7	; acende led 7 e 6
	bcf	GPIO,LED6
	call	ms250		; espera 250 ms
	bsf	GPIO,LED7
	bsf	GPIO,LED6
	call	ms250		; espera 1 ms
	call	ms250		
	call	ms250		
	call	ms250		
	goto 	principal

S2On:
	btfss	GPIO,S3
	goto	S2S3On
SoS2:
	bcf	GPIO,LED7	; pisca led 7 por 2 vezes
	call	ms250
	bsf	GPIO,LED7	
	call	ms250
	bcf	GPIO,LED7	
	call	ms250
	bsf	GPIO,LED7	
	call	ms250
	call	ms250		; espera 1 ms
	call	ms250		
	call	ms250		
	call	ms250		
	goto 	principal

S3On:
	btfss	GPIO,S2
	goto	S2S3On
SoS3:
	bcf	GPIO,LED6	; pisca led 6 por 2 vezes
	call	ms250
	bsf	GPIO,LED6	
	call	ms250
	bcf	GPIO,LED6	
	call	ms250
	bsf	GPIO,LED6	
	call	ms250
	call	ms250		; espera 1 ms
	call	ms250		
	call	ms250		
	call	ms250		
	goto 	principal

S2S3On:
	bcf	GPIO,LED7	; pisca led 7 por 2 vezes
	bcf	GPIO,LED6
	call	ms250
	bsf	GPIO,LED7	
	bsf	GPIO,LED6
	call	ms250
	bcf	GPIO,LED7
	bcf	GPIO,LED6	
	call	ms250
	bsf	GPIO,LED7	
	bsf	GPIO,LED6
	call	ms250
	call	ms250		; espera 1 ms
	call	ms250		
	call	ms250		
	call	ms250		
	goto 	principal

;...............................Rotina de tempo de 250 ms.

ms250:
	movlw	250		;1
	movwf	tempo		;1

ms250a:
	movlw 	249           	;1
	movwf	X           	;1

ms250b:
	nop               	;1
	decfsz 	X        	;1
	goto  	ms250b     	;2

	decfsz	tempo		;1
	goto 	ms250a       	;2

	return

	END			; fim do programa fonte

